## Manual Resolver

Deployed on testnet on address `kf-Cn1bSHIjalMGU3GUWWqxOfnNEQTV2h1Nq9hEBC08vG9Ln`
(pk and addr files are included in this package)

### Local Test

   0. Adjust stack in `4_test_local.fif` before `PROGRAM{` and arguments in `4_test_local.fc` 
   1. Run in `manual resolver` directory `func -PS ./stdlib.fc ./4_test_local.fc -o "4_test_local.code"`
   2. copy program code and place it inside `4_test_local.fif`
   3. Run test `fift -I ~/ton/ton/crypto/fift/lib 4_test_local.fif`
   4. Investigate results. 
   5. Correct result for code included is: 
      - `11 CS{Cell{001474657374546172676574} bits: 0..80; refs: 0..0} 8 CS{Cell{001c74657374526f6f74546172676574} bits: 0..112; refs: 0..0} 0 (null) 0 (null) 1000 2000 0`
   6. To test init message you can use `4_test_init.fif` based on issue `#121`

### Deployment 

   1. generate deployment request:
      1. `func -PS ../stdlib.fc ../4.fc -o 4.fif` 
      2. `../fift -I ~/ton/ton/crypto/fift/lib -s new-manual-resolver.fif -1` // -1 is workchain id
         - Generates key pair as well (generated privkey is used as initial owner)
         - Prints contract initial and bounce address
   2. Make source generated address has available balance 
      1. Get Grams through testgiver or telegram bot `@test_ton_bot`
   3. send deployment request
   4. `lite-client -a <IP address> -p <pub key> -c "sendfile new-resolver-query.boc"`
      
### Usage 

   - `runmethod <addr> dnsresolve <slice> <cat>`
      - e.g. `runmethod kf-Cn1bSHIjalMGU3GUWWqxOfnNEQTV2h1Nq9hEBC08vG9Ln dnsresolve x{74657374006e6573746564} 1`
   #### change owner, set domain, remove domain
   
   - for sending messages on behalf of contract owner you can use scripts in scripts folder
   
### NOTES

- query_id based on current time is used as replay protection
- although contract was tested locally. I had really hard time do debug messages on blockchain and as such the scripts in `scripts` folder are not fully tested. 
   - in case I would manage to finish testing before deadline I will upload update.